package demo.ObjectDimension;

import java.io.*;

public class Assignment extends Expression
{

   public Assignment ( String variableName,
                       Expression value )
      {    // BEGIN Expression
         _variable = new Variable ( variableName );
         _variable.setValue ( value );
      };   // END Expression

   public String operatorName()
      {    // BEGIN operatorName
         return "Assignment";
      };   // END operatorName

   public String getName()
      {
         return _variable.getName();
      };   // END getName

   public Expression getValue()
      {
         return _variable.getValue();
      };   // END getValue

   public void setValue ( Expression newValue )
      {
         _variable.setValue ( newValue );
      };   // END setValue


   private Variable _variable;


   // Check feature:
   public boolean check()
      {
         String var = getName();
         Expression value = getValue();

         return ( (var != null) &&
                  (value != null) &&
                  (value.check()) );

      };   // END check

   // Display feature:
   public void display ( PrintStream displayDevice )
      {
         displayDevice.print ( getName()
                               + " "
                               + operatorName() );
         getValue().display ( displayDevice );
      };   // END display

   // Eval feature:
   public float eval()
      {
         return getValue().eval();
      };   // END eval


}  // END class Assignment
