package demo.ObjectDimension;

import java.io.*;

public abstract class BinaryOperator extends Expression
{

   public BinaryOperator()
      {    // BEGIN BinaryOperator
         _leftOperand = null;
         _rightOperand = null;
      };   // END BinaryOperator

   public BinaryOperator ( Expression left,
                           Expression right )
      {
         super();
         setLeftOperand ( left );
         setRightOperand ( right );
      };   // END BinaryOperator

   public String operatorName()
      {    // BEGIN operatorName
         return "BinaryOperator";
      };   // END operatorName

   public Expression getLeftOperand()
      {    // BEGIN getLeftOperand
         return _leftOperand;
      };   // END getLeftOperand

   public void setLeftOperand ( Expression newValue )
      {    // BEGIN setLeftOperand
         _leftOperand = newValue;
      };   // END setLeftOperand

   public Expression getRightOperand()
      {    // BEGIN getRightOperand
         return _rightOperand;
      };   // END getRightOperand

   public void setRightOperand ( Expression newValue )
      {    // BEGIN setRightOperand
         _rightOperand = newValue;
      };   // END setRightOperand


   private Expression _leftOperand;
   private Expression _rightOperand;


   // Check feature:
   public boolean check()
      {
         Expression leftOperandValue = getLeftOperand();
         Expression rightOperandValue = getRightOperand();

      //!HOdebug         System.out.println ( "DEBUG:  in BinaryOperator.check" );

         return ( (leftOperandValue != null) &&
                  (rightOperandValue != null) &&
                  (leftOperandValue.check()) &&
                  (rightOperandValue.check()) );
      };   // END check


   // Display feature:
   public void display ( PrintStream displayDevice )
      {
         displayDevice.print ( "(" );
         _leftOperand.display ( displayDevice );
         displayDevice.print ( " " + operatorName() + " ");
         _rightOperand.display ( displayDevice );
         displayDevice.print ( ")" );
      };   // END display


   // Evaluation feature:


}   // END class BinaryOperator
