package demo.ObjectDimension;

import java.io.*;

public abstract class Expression
{

   public Expression()
      {    // BEGIN Expression
      };   // END Expression

   public void process()
      {    // BEGIN process
         System.out.println ( "Beginning expression processing..." );

         // Notice that the order and content are hard-coded here:
         check_process();
         eval_process();
         display_process();
      };   // END process

   public String operatorName()
      {    // BEGIN operatorName
         return "Expression";
      };   // END operatorName


   // Expression checking feature:
   public boolean check()
      {
         // By default, expressions are correct
         return true;
      };   // END check

   public void check_process()
      {    // BEGIN check_process
         if ( check() )
            System.out.println ( "   Expression is valid" );
         else
            System.out.println ( "   Expression is INVALID" );
      };   // END check_process


   // Expression display feature:
   public void display ( PrintStream displayDevice )
      {
         displayDevice.print ( operatorName() );
      };   // END display

   public void display_process()
      {    // BEGIN display_process
         display ( System.out );
         System.out.println();
      };   // END display_process


   // Expression evaluation feature:
      //!HOtodo   public abstract float eval();
   public float eval() 
      {
        return 0;
      }

   public void eval_process()
      {    // BEGIN eval_process
         System.out.println ( eval() );
      };   // END eval_process


}  // END class Expression
