package demo.Observer;

import java.io.*;

//!PT990831  Should *implement* Observer, but interfaces aren't implemented
//yet, so Observer is defined as an abstract class
public class Logger /*implements*/ extends Observer
{

   public void _acceptNotification ( Object[] parameterList )
      {
         // parameterList should have 2 elements:  [before|after] and the
         // name of the logged method.

         // Sanity test:  check for 2 parameters
         if ( parameterList.length != 2 )
            throw new Error ( "Parameter list has "
                              + parameterList.length
                              + " elements instead of 2" );

         _logStream.println ( "Logger:  "
                              + parameterList[0]
                              + " method "
                              + parameterList[1] );

      };   // END acceptNotification

  private static PrintStream _logStream;

  static {
     // open the log file for writing
     try {
       OutputStream rawUnparseStream = new FileOutputStream("expression.log");
       _logStream = new PrintStream(rawUnparseStream);
     }
     catch (IOException e) {
       System.out.println("Error: Cannot open expression.log for writing");
     }
  }

};   // END class Logger
