package demo.StyleChecker;

import java.util.Enumeration;
import java.util.Vector;

public abstract class Expression
{

   public Enumeration children()
      {
         return (new Vector().elements());   // A dummy impl
      }

   public boolean check()
      {
         return true;   // A dummy impl; must be overridden in subclasses!
      }


   protected int countNestingDepth ( int parentsDepth )
      {
         int maxChildDepth = parentsDepth;
         Enumeration operands = children();

         while ( operands.hasMoreElements() )
            maxChildDepth
               = max ( ( (Expression)operands.nextElement() ).
                          countNestingDepth ( parentsDepth + 1 ),
                       maxChildDepth );

         return maxChildDepth;
      };   // END countNestingDepth

   protected int countNumberOfLiterals ( int currentNumber )
      {
         int numLiteralsUsed = 0;
         Enumeration operands = children();

         while ( operands.hasMoreElements() )
            numLiteralsUsed
               += ( (Expression)operands.nextElement() ).
                     countNumberOfLiterals ( numLiteralsUsed );

         return numLiteralsUsed;
      };   // END countNumberOfLiterals

   private static int max ( int first,
                            int second )
      {
         if ( first > second )
            return first;
         else
            return second;
      };   // END max


   private static boolean summarizeCheck ( boolean[] returnValues )
      {
         // System.out.println("   Executing summarizeCheck");
         for ( int i = 0;
               i < returnValues.length;
               i++ )
           if ( returnValues[i] == false )
              return false;

         return true;
      };   // END summarizeCheck


}   // END class Expression













