package demo.StyleChecker;

import java.io.*;

public abstract class Operator extends Expression
{

   public boolean check()
      {
         //         System.out.println ( "Doing style check of operator" );
         return ( checkNumberOfLiterals() &&
                  checkNestingDepth() );
      };   // END check


   protected boolean checkNumberOfLiterals()
      {
         _numLiteralsUsed = countNumberOfLiterals ( 0 );
         if ( _numLiteralsUsed > LITERAL_THRESHOLD ) {
           System.out.println ( "BAD STYLE: Too many literals ("
                                + _numLiteralsUsed + ")" );
           return false;
         }
         else
           return true;
      };   // END checkNumberOfLiterals

   protected boolean checkNestingDepth()
      {
         _nestingDepth = countNestingDepth ( 0 );
         if ( _nestingDepth > NESTING_THRESHOLD ) {
           System.out.println ( "BAD STYLE: Too deeply nested ("
                                + _nestingDepth +")" );
           return false;
         }
         else
           return true;
      };   // END checkNestingDepth


   private int _numLiteralsUsed;
   private int _nestingDepth;

   private static final int LITERAL_THRESHOLD = 4;
   private static final int NESTING_THRESHOLD = 3;

}   // END class Operator
